unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, ExtCtrls,
  Menus, ComCtrls, gfx_files, UApoyo, UFPuntuales,
  ImgList, ToolWin;

type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Abrir1: TMenuItem;
    StatusBar1: TStatusBar;
    Propiedades1: TMenuItem;
    Varios1: TMenuItem;
    FPuntuales1: TMenuItem;
    Negativo1: TMenuItem;
    Salvar1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Negativo2: TMenuItem;
    onosdeGris1: TMenuItem;
    Luminancia1: TMenuItem;
    N1: TMenuItem;
    Logaritmo1: TMenuItem;
    StatusBar2: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ImageList1: TImageList;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    Gamma1: TMenuItem;
    Histograma1: TMenuItem;
    
    procedure Abrir1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Negativo1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure Negativo2Click(Sender: TObject);
    procedure onosdeGris1Click(Sender: TObject);
    procedure Logaritmo1Click(Sender: TObject);
    procedure Gamma1Click(Sender: TObject);
    procedure Histograma1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    BMap  : TBitMap;
    M1,M2 : Mat3d;
  end;

var
  Form1: TForm1;

implementation

uses UCap_R, UHisto;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  BMap := TBitMap.Create;
end;

procedure TForm1.Abrir1Click(Sender: TObject);
var
  nom : string;
begin
  OpenDialog1.Filter := gfx_files._OpenFilterString;
  if OpenDialog1.Execute then begin
    nom := Opendialog1.FileName;
    gfx_Files.LoadAnyImageToBMP(BMap,nom,false,0,0);


    BM2Mat(BMap,M1);

    _x1 := 0;
    _y1 := 0;

    _x2 := M1.nc;
    _y2 := M1.nr;

    SetMat(M2,0,0,0);
    Image1.Picture.Assign(BMap) ;
  end;
end;

procedure TForm1.Salvar1Click(Sender: TObject);
var
  nom : string;
begin
  SaveDialog1.Filter := gfx_files._SaveFilterString;
  if SaveDialog1.Execute then begin
    nom := SaveDialog1.FileName;
    gfx_files.SaveBMPToAnyFile(BMap,nom,0,0);
  end;

end;

procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y : Integer);
var
 pix    : integer;
 r,g, b : byte;
begin

  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  pix := Image1.Canvas.Pixels[X,Y];
  r := GetRValue (pix);
  g := GetGValue (pix);
  b := GetBValue (pix);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);
end;

// Negativo: z' = Lamb-z
procedure TForm1.Negativo1Click(Sender: TObject);
var
  x,y,pix  : integer;
  r,g,b    : integer;
begin
  for y := 0 to BMap.Height - 1 do
    for x := 0 to BMap.Width - 1 do begin
      pix := BMap.Canvas.Pixels[X,Y];
      r := GetRValue (pix);
      g := GetGValue (pix);
      b := GetBValue (pix);

      r := _Lamb-r;
      g := _Lamb-g;
      b := _Lamb-b;

      pix := RGB(r,g,b);
      BMap.Canvas.Pixels[X,Y] := pix;
    end;
  Image1.Picture.Assign(BMap);
end;

// Filtro de Negativo con Matrices
procedure TForm1.Negativo2Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FP_Negativo(M1,M2);

  Mat2BM(M2,BMap);
  Image1.Picture.Assign(BMap);
end;

// tonos de Gris
procedure TForm1.onosdeGris1Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FP_Grises(M1,M2);

  Mat2BM(M2,BMap);
  Image1.Picture.Assign(BMap);
end;

// Logaritmo / Rango Dinmica
procedure TForm1.Logaritmo1Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FP_Logaritmo(M1,M2);

  Mat2BM(M2,BMap);
  Image1.Picture.Assign(BMap);
end;

// Filtro o Correccion Gamma
procedure TForm1.Gamma1Click(Sender: TObject);
var
  gam  : single;
  verr : integer;
begin
  // para leer el valor de gamma conviene una interface
  // - se construye y luego de invoca
  // - se toma el valor(es) deseado(s) de ella y se usa(n)

  FCapR.ShowModal;
  if (FCapR.ModalResult = mrOK) then begin
    //  Conversion directa
    //  gam := StrToFloat(FCapR.Edit1.Text);

    // validando la entrada
    val(FCapR.Edit1.Text,gam,verr);
    if (verr<>0) then begin
      ShowMessage('Error de entrada, revise ...');
      exit;
    end;

    Mat2Mat(M2,M1);

    FP_Gamma(M1,M2,gam);

    Mat2BM(M2,BMap);
    Image1.Picture.Assign(BMap);
  end;
end;



procedure TForm1.Histograma1Click(Sender: TObject);
begin
  FormHisto.Show;
end;

end.
